#!/usr/bin/env python

from bottle import route, run, get, post, request
from definiciones import *
from datetime import *

# Si se escribe en el navegador http://localhost:8080/ o 
# http://localhost:8080/tuiteos, entonces ejecuta esta funcion.
@route('/') 
@route('/tuiteos')
def index():
    tuiteos = obtener_tuiteos()
    contenido = []
    contenido.append(cabeza)
    contenido.append(post)
    contenido.append('<table>')
    for a, t, f in tuiteos:
        contenido.append('''
          <tr>
            <td>{0}</td>
            <td>{1}</td>
          </tr>'''.format(hipervinculo_usuario(a), procesar_mensaje(t, f)))
    contenido.append('</table>')
    contenido.append(cola)
    return '\n'.join(contenido)
 


@route('/publicado', method='POST')
def publicado():

    contenido = []
    contenido.append(cabeza)
    
    print request.forms.get('user')
    print request.forms.get('post')

    if request.forms.get('user') == "" or request.forms.get('post') == "" or request.forms.get('user') == "@":
       mensaje = "Mensaje incorrecto.<br>"
    else:	
       formato  = "<strong><i>{0}</i></strong> escribio: <i>{1}</i>.<br><br>"
       mensaje = formato.format(request.forms.get('user'), request.forms.get('post'))
       agregar_tuit(request.forms.get('user'), request.forms.get('post'))
	   
    contenido.append(mensaje)
    contenido.append(mensaje_volver())
    contenido.append(cola)
    return '\n'.join(contenido)
    
    
@route('/htag/:htag')
def hashtag(htag):
    contenido = []
    contenido.append(cabeza) 
    contenido.append(mensaje_volver())
    htag = '#' + htag
    titulo = '<h2>Revisando todos los mensajes con hashtag {0}</h2>'
    
    contenido.append(titulo.format(htag))
    

    tuiteos = obtener_tuiteos()
    print tuiteos
    contenido.append('<table>')
    for u, m, f in tuiteos: 
      if htag in m:
         contenido.append('<tr>') # inicio fila 
         contenido.append('<td>* {0} </td><td>{1}</td>'.format(hipervinculo_usuario(u), procesar_mensaje(m, f)))
         contenido.append('</tr>') # fin fila 
    contenido.append('</table>')

    contenido.append(cola)
    return '\n'.join(contenido)




@route('/usuario/:u')
def tuiteos(u):
    tuiteos = obtener_tuiteos()
    contenido = []
    contenido.append(cabeza)
    contenido.append('{0}<h2>Tuiteos de {1}</h2>'.format(mensaje_volver(), u))
    
    menciones = cantidad_de_menciones(u)
    tuits = cantidad_de_tuits(u)
    contenido.append('(El usuario tiene {0} menciones y ha tuiteado {1} veces)<br><br>'.format(menciones, tuits))

    contenido.append('<table>')
    for a, t, f in tuiteos:
        if a == u:
            contenido.append('<tr><td>* {0}</td></tr>'.format(procesar_mensaje(t, f)))
    contenido.append('</table>')
    contenido.append(cola)
    return '\n'.join(contenido)



def procesar_mensaje(mensaje, fecha):

  msg = poner_hipervinculos(mensaje) 
  tiempo = momento_del_tuit(fecha)
  
  return msg + tiempo



def mensaje_volver():
  return '<a href="/">Volver</a>'
  
 
def hipervinculo_usuario(usuario):
  return '<a href="/usuario/{0}">@{0}</a>'.format(usuario, usuario)


def hipervinculo_hashtag(tema):
  return '<a href="/htag/{0}">{1}</a>'.format(tema[1:], tema)


def fecha_hora_actual():
    return str(datetime.today())




####################################################################
###### USTED DEBE IMPLEMENTAR LAS FUNCIONES QUE ESTAN ABAJO ########
###### NO MODIFIQUE LAS DE ARRIBA ##################################


# la funcion debe retornar la cantidad de menciones que tiene el usuario 
def cantidad_de_menciones(usuario):
  return '10'


# la funcion debe retornar la cantidad de tuits que ha hecho el usuario 
def cantidad_de_tuits(usuario):
  return '5'
 

def agregar_tuit(usuario, mensaje):
   print "Esta funcion debe agregar un nuevo registro al archivo con el formato que corresponde. La funcion no debe retornar nada."
 

def obtener_tuiteos():
    tuiteos = [('pepito', 'Estoy feliz #tarea2', '2012-10-29 10:50')]
    return tuiteos


def poner_hipervinculos(mensaje):
  return mensaje



def momento_del_tuit(fecha_tuit):
  return '<i><font size="-1"> ... (publicado hace unos momentos)</font></i>'



# No borrar ni modificar
run(host='localhost', port=8080)

